//
//  MLAppDelegate.m
//  SIPSample
//
//  Created by MrLee on 14-9-4.
//  Copyright (c) 2014 PortSIP Solutions, Inc. All rights reserved.
//

#import "MLAppDelegate.h"
#import "MLMainViewController.h"

#import "Reachability.h"

#import <sys/socket.h>
#import <netinet/in.h>
#import <SystemConfiguration/SystemConfiguration.h>

@interface MLAppDelegate()
@property (nonatomic, strong) MLMainViewController *mainViewController;
@property (nonatomic, strong)Reachability* internetReach;
@end

@implementation MLAppDelegate

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
    
    self.mainViewController = [[MLMainViewController alloc] initWithNibName:@"MLMainViewController" bundle:nil];
    [self.window.contentView addSubview:self.mainViewController.view];
    
    self.internetReach = [Reachability reachabilityForInternetConnection];
    self.internetReach.reachabilityBlock = self.mainViewController.reachabilityBlock;
    self.mainViewController.mNetWorkReachable =self.internetReach.isReachable;
    
    [self.internetReach startNotifier];
}

- (void)applicationWillTerminate:(NSNotification *)notification
{
    [self.internetReach stopNotifier];
    [self.mainViewController deRegisterFromServer];
}
@end
