//
//  MLMainViewController.m
//  SIPSample
//
//  Created by MrLee on 14-9-5.
//  Copyright (c) 2014 PortSIP Solutions, Inc. All rights reserved.
//

#import "MLMainViewController.h"
#import "MLSession.h"
#import "MLTransferWindowController.h"
#import <PortSIPSDK/PortSIPSDK.h>

#define kRegularExp @"sip:.{1,}@.{1,}$"

typedef enum : NSUInteger {
    TransferType_None,
    TransferType_Transfer,
    TransferType_AttendTransfer,
} TransferType;

@interface MLMainViewController ()<PortSIPEventDelegate, NSTableViewDataSource, NSAlertDelegate, MLTransferWindowControllerDelegate>
{
    PortSIPSDK *_mPortSipSDK;
    
    MLSession *mSessionArray[MAX_LINES];
    
    BOOL _mSIPInitialized;

    long _mCurrentlyLine;
    
    NSMutableArray *_logData;
    
    TransferType transferType;
    

    
    int mRemoteVideoWidth;
    int mRemoteVideoHeight;
    
    NSTimer *mAutoRegisterTimer;
    int mAutoRegisterRetryTimes;
}
@property (nonatomic, strong) MLTransferWindowController *transfer;

//Login
@property (weak) IBOutlet NSTextField *textFieldUsername;
@property (weak) IBOutlet NSTextField *textFieldPassword;
@property (weak) IBOutlet NSTextField *textFieldDisplayname;
@property (weak) IBOutlet NSTextField *textFieldAuthname;
@property (weak) IBOutlet NSTextField *textFieldUserdomain;
@property (weak) IBOutlet NSTextField *textFieldSipserver;
@property (weak) IBOutlet NSTextField *textFieldSipport;
@property (weak) IBOutlet NSTextField *textFieldStunServer;
@property (weak) IBOutlet NSTextField *textFieldStunport;
@property (weak) IBOutlet NSComboBox *comboboxTransport;
@property (weak) IBOutlet NSComboBox *comboboxSRTP;
@property (weak) IBOutlet NSButton *checkboxRegisterToServer;
@property (weak) IBOutlet NSButton *buttonOnline;
@property (weak) IBOutlet NSButton *buttonOffline;

//Call
@property (weak) IBOutlet NSTextField *textFieldPhonenumber;
@property (weak) IBOutlet NSButton *buttonOne;
@property (weak) IBOutlet NSButton *buttonTwo;
@property (weak) IBOutlet NSButton *buttonThree;
@property (weak) IBOutlet NSButton *buttonFour;
@property (weak) IBOutlet NSButton *buttonFive;
@property (weak) IBOutlet NSButton *buttonSix;
@property (weak) IBOutlet NSButton *buttonSeven;
@property (weak) IBOutlet NSButton *buttonEight;
@property (weak) IBOutlet NSButton *buttonNine;
@property (weak) IBOutlet NSButton *buttonStar;
@property (weak) IBOutlet NSButton *buttonZero;
@property (weak) IBOutlet NSButton *buttonSharp;
@property (weak) IBOutlet NSComboBox *comboboxLines;

@property (weak) IBOutlet NSButton *checkboxSDP;
@property (weak) IBOutlet NSButton *checkboxPackage;
@property (weak) IBOutlet NSButton *checkboxDND;
@property (weak) IBOutlet NSButton *checkboxAutoanswer;
@property (weak) IBOutlet NSButton *checkboxConference;
@property (weak) IBOutlet NSButton *checkboxAnswervideocall;
@property (weak) IBOutlet NSButton *checkboxMakevideocall;

@property (weak) IBOutlet NSButton *buttonDial;
@property (weak) IBOutlet NSButton *buttonHangup;
@property (weak) IBOutlet NSButton *buttonAnswer;
@property (weak) IBOutlet NSButton *buttonReject;
@property (weak) IBOutlet NSButton *buttonHold;
@property (weak) IBOutlet NSButton *buttonUnhold;
@property (weak) IBOutlet NSButton *buttonTransfer;
@property (weak) IBOutlet NSButton *buttonAttendtransfer;

//Video

@property (weak) IBOutlet NSComboBox *comboboxResolution;
@property (weak) IBOutlet NSSlider *sliderQuality;
@property (weak) IBOutlet NSButton *buttonOptions;
@property (weak) IBOutlet NSButton *buttonLocalVideo;
@property (weak) IBOutlet NSButton *buttonSendvideo;
@property (weak) IBOutlet NSButton *buttonStopvideo;
@property (weak) IBOutlet PortSIPVideoRenderView *uiviewLocal;
@property (weak) IBOutlet PortSIPVideoRenderView *uiviewRemote;

//Codec
@property (weak) IBOutlet NSButton *checkboxG711ulaw;
@property (weak) IBOutlet NSButton *checkboxG711alaw;
@property (weak) IBOutlet NSButton *checkboxG729;
@property (weak) IBOutlet NSButton *checkboxILBC;
@property (weak) IBOutlet NSButton *checkboxGSM;
@property (weak) IBOutlet NSButton *checkboxAMR;
@property (weak) IBOutlet NSButton *checkboxG722;
@property (weak) IBOutlet NSButton *checkboxG7221;
@property (weak) IBOutlet NSButton *checkboxAMRWB;
@property (weak) IBOutlet NSButton *checkboxSPEEXWB;
@property (weak) IBOutlet NSButton *checkboxSPEEX;
@property (weak) IBOutlet NSButton *checkboxOpus;
@property (weak) IBOutlet NSButton *checkboxH264;
@property (weak) IBOutlet NSButton *checkboxVP8;
@property (weak) IBOutlet NSButton *checkboxVP9;


//Log
@property (weak) IBOutlet NSTableView *tableViewLog;

@property (weak) IBOutlet NSButton *buttonClear;


//Audio
@property (weak) IBOutlet NSSlider *sliderSpeaker;
@property (weak) IBOutlet NSSlider *sliderMicrophone;
@property (weak) IBOutlet NSButton *checkboxMuteMicrophone;
@property (weak) IBOutlet NSComboBox *comboboxMicrophone;
@property (weak) IBOutlet NSComboBox *comboboxSpeaker;
@property (weak) IBOutlet NSComboBox *comboboxCameara;

//Audio and Video Recording
@property (weak) IBOutlet NSButton *buttonRecorddirectory;
@property (weak) IBOutlet NSButton *checkboxAudioStreamCallback;
@property (weak) IBOutlet NSTextField *textFieldRecorddirectory;
@property (weak) IBOutlet NSTextField *textFieldRecordFilename;
@property (weak) IBOutlet NSButton *buttonStartRecord;
@property (weak) IBOutlet NSButton *buttonStopRecord;

//Play audio file
@property (weak) IBOutlet NSButton *buttonPlayFile;
@property (weak) IBOutlet NSTextField *textFieldPlayFilename;
@property (weak) IBOutlet NSButton *buttonStartPlay;
@property (weak) IBOutlet NSButton *buttonStopPlay;



//Call Forward
@property (weak) IBOutlet NSTextField *textFieldForward;
@property (weak) IBOutlet NSButton *checkboxForward;
@property (weak) IBOutlet NSButton *buttonForwardEnable;
@property (weak) IBOutlet NSButton *buttonForwardDisable;


@property (weak) IBOutlet NSButton *checkboxAEC;
@property (weak) IBOutlet NSButton *checkboxVAD;
@property (weak) IBOutlet NSButton *checkboxCNG;
@property (weak) IBOutlet NSButton *checkboxAGC;
@property (weak) IBOutlet NSButton *checkboxANS;
@property (weak) IBOutlet NSButton *checkboxNACK;

@end

@implementation MLMainViewController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];

    if (self) {
        __weak MLMainViewController * weakSelf = self;
        self.reachabilityBlock = ^(Reachability *reachability, SCNetworkConnectionFlags flags) {
            weakSelf.mNetWorkReachable =[reachability isReachable];
            dispatch_async(dispatch_get_main_queue(), ^{
                [weakSelf refreshRegister];
            });
            
        };
        // Initialization code here.
    }
    return self;
}

- (void)loadView
{
    [super loadView];
    
    [self initSessionArray];
    
    _mSIPInitialized = NO;
    _mCurrentlyLine = LINE_BASE;
    transferType = TransferType_None;
    self.sipRegistrationStatus = LOGIN_STATUS_OFFLINE;
    
    [_comboboxTransport selectItemAtIndex:0];
    [_comboboxSRTP selectItemAtIndex:0];
    [_comboboxResolution selectItemAtIndex:1];
    [_comboboxLines selectItemAtIndex:0];
    _logData = [[NSMutableArray alloc] init];
}

- (void)initSessionArray
{
    for (int i = LINE_BASE; i < MAX_LINES; ++i) {
        mSessionArray[i] = [[MLSession alloc] init];
    }
}

#pragma mark - TableView datasource methord
- (NSInteger)numberOfRowsInTableView:(NSTableView *)tableView
{
    return _logData.count;
}

- (NSView*)tableView:(NSTableView *)tableView viewForTableColumn:(NSTableColumn *)tableColumn row:(NSInteger)row
{
    NSTableCellView *cellView = [tableView makeViewWithIdentifier:tableColumn.identifier owner:self];
    if ([tableColumn.identifier isEqualToString:@"LogColumn"]) {
        [cellView.textField setStringValue:_logData[row]];
    }
    return cellView;
}

- (void)showAlertWithText:(NSString *)text
{
    NSAlert *alert = [[NSAlert alloc] init];
    [alert setMessageText:@"Information"];
    [alert setInformativeText:text];
    [alert setAlertStyle:NSWarningAlertStyle];
    [alert runModal];
}

-(NSString *) get_current_app_path
{
    NSString* path = @"";
    NSString* str_app_full_file_name = [[NSBundle mainBundle] bundlePath];
    NSRange range = [str_app_full_file_name rangeOfString:@"/" options:NSBackwardsSearch];

    if (range.location != NSNotFound)
    {
        path = [str_app_full_file_name substringToIndex:range.location];
        path = [path stringByAppendingFormat:@"%@",@"/"];
    }
    return path;
}

#pragma mark - Register Method
-(NSString*)accoutValidate{
    NSString* error=nil;
    
    if ([_textFieldUsername stringValue].length <= 0) {
        error = @"The user name does not allows empty.";
    }
    
    if ([_textFieldPassword stringValue].length <= 0) {
        error = @"The password does not allows empty.";
    }
    
    if ([_textFieldSipserver stringValue].length <= 0) {
        error = @"The Sip server does not allows empty.";
    }
    
    int SIPServerPort = 0;
    if ([_textFieldSipport stringValue].length > 0) {
        SIPServerPort = [[_textFieldSipport stringValue] intValue];
        if (SIPServerPort > 65535 || SIPServerPort <= 0) {
            error = @"The Sip server port is out of range.";
        }
    }
    
    int StunServerPort = 0;
    if ([_textFieldStunport stringValue].length > 0) {
        StunServerPort = [[_textFieldStunport stringValue] intValue];
        if (StunServerPort > 65535 || StunServerPort <= 0) {
            error = @"The Stun server port is out of range.";
        }
    }
    
    return error;
}

- (BOOL)registerToServer:(BOOL)needTips
{
    
    TRANSPORT_TYPE transportType = TRANSPORT_UDP;
    switch (_comboboxTransport.indexOfSelectedItem) {
        case 0:
            transportType = TRANSPORT_UDP;
            break;
        case 1:
            transportType = TRANSPORT_TLS;
            break;
        case 2:
            transportType = TRANSPORT_TCP;
            break;
        case 3:
            transportType = TRANSPORT_PERS_UDP;
            break;
        case 4:
            transportType = TRANSPORT_PERS_TCP;
            break;
        default:
            break;
    }
    [_uiviewLocal initVideoRender];
    [_uiviewRemote initVideoRender];
    
    _mPortSipSDK = [[PortSIPSDK alloc] init];
    _mPortSipSDK.delegate = self;
    
    NSString *stunServer = [_textFieldStunServer stringValue];
    
    int localPort = 10000 + arc4random() % 1000;
    NSString *localIPaddress = @"0.0.0.0";
    NSString *logPath = [self get_current_app_path];
    NSString *dnsServers = @"";//e.g "8.8.8.8;8.8.4.4"
    
    int SIPServerPort = [[_textFieldSipport stringValue] intValue];
    int StunServerPort = [[_textFieldStunport stringValue] intValue];
    
    int ret = [_mPortSipSDK initialize:transportType localIP:localIPaddress localSIPPort:localPort loglevel:PORTSIP_LOG_NONE logPath:logPath maxLine:MAX_LINES agent:@"PortSIP SDK for MAC"  audioDeviceLayer:0 videoDeviceLayer:0 TLSCertificatesRootPath:@"" TLSCipherList:@"" verifyTLSCertificate:NO dnsServers:dnsServers];
    
    if (ret != 0) {
        [self addLineStringToTableView:[NSString stringWithFormat:@"initializeSDK failure ErrorCode = %d", ret]];
        [_mPortSipSDK unInitialize];
        return NO;
    }
    
    [self addLineStringToTableView:@"Initialized success"];
    
    _mSIPInitialized = YES;
    
    [self loadDevices];
    
    NSString *userName = [_textFieldUsername stringValue];
    NSString *password = [_textFieldPassword stringValue];
    NSString *userDomain = [_textFieldUserdomain stringValue];
    NSString *sipServer = [_textFieldSipserver stringValue];
    NSString *displayName = [_textFieldDisplayname stringValue];
    NSString *authName = [_textFieldAuthname stringValue];
    NSString *outboundServer = @"";
    int outboundPort = 0;

    
    [_mPortSipSDK setUser:userName displayName:displayName authName:authName password:password userDomain:userDomain SIPServer:sipServer SIPServerPort:SIPServerPort STUNServer:stunServer STUNServerPort:StunServerPort outboundServer:outboundServer outboundServerPort:outboundPort];
    
    if (ret != 0) {
        [self showAlertWithText:[NSString stringWithFormat:@"setUser failure ErrorCode = %d", ret]];
        [_mPortSipSDK unInitialize];
        //[_logData removeAllObjects];
        [self.tableViewLog reloadData];
        return NO;
    }
    
    [self addLineStringToTableView:@"Succeeded set user information."];
    
    [self setSRTPType];
    
    [self setLicenseKey:@"PORTSIP_TEST_LICENSE" AlterTips:needTips];
    
    [self setVideoResolution];
    [self setVideoQuality];
    
    [self updateAudioCodecs];
    [self updateVideoCodecs];
    
    [self initSettings];
    [self updatePrackSetting];
    
    if (_checkboxRegisterToServer.state) {
        ret = [_mPortSipSDK registerServer:90 retryTimes:0];
        if (ret != 0) {
            _mSIPInitialized = NO;
            [_mPortSipSDK unInitialize];
            //[_logData removeAllObjects];
            [self.tableViewLog reloadData];
            [self addLineStringToTableView:@"register to server failed."];
            return _mSIPInitialized;
        }
        
        [self addLineStringToTableView:@"Registering..."];
    }
    self.sipRegistrationStatus = LOGIN_STATUS_REGISTERING;
    return _mSIPInitialized;
}

-(BOOL)setLicenseKey:(NSString*)license AlterTips:(BOOL)alterTips{
    BOOL result=true;
    
    int ret = [_mPortSipSDK setLicenseKey:license];
    NSString* tips = nil;
    if (ret == ECoreTrialVersionLicenseKey) {
        tips = @"This sample was built base on evaluation PortSIP VoIP SDK, which allows only three minutes conversation. The conversation will be cut off automatically after three minutes, then you can't hearing anything. Feel free contact us at: sales@portsip.com to purchase the official version.";
    }else if (ret == ECoreWrongLicenseKey){
        tips = @"The wrong license key was detected, please check with sales@portsip.com or support@portsip.com";
        [_mPortSipSDK unInitialize];
        result = NO;
    }else{
        return TRUE;
    }
    if(alterTips){
        [self showAlertWithText:tips];
    }else{
        [self addLineStringToTableView:tips];
    }
    
    return result;
}

- (void)refreshRegister{
    if(self.mNetWorkReachable){
        switch (self.sipRegistrationStatus) {
            case LOGIN_STATUS_OFFLINE:
                break;
            case LOGIN_STATUS_REGISTERING:
                [self addLineStringToTableView:@"refreshRegister Registration..."];
                break;
            case LOGIN_STATUS_ONLINE:
                [_mPortSipSDK refreshRegistration:0];
                [self addLineStringToTableView:@"Refresh Registration..."];
                break;
            case LOGIN_STATUS_FAILUE:
                [self addLineStringToTableView:@"Retry a new register..."];
                [self deRegisterFromServer];
                [self registerToServer:false];
                break;
        }
    }else{
        [self addLineStringToTableView:@"Network Unavailable!"];
        //[self deRegisterFromServer];
    }
}

- (void)updatePrackSetting
{
    if (_mSIPInitialized == NO) {
        return;
    }
    
    [_mPortSipSDK enableReliableProvisional:_checkboxPackage.state];
}

- (void)checkDND
{
    if (_mSIPInitialized == NO) {
        return;
    }
    
    [_mPortSipSDK setDoNotDisturb:_checkboxDND.state];
}

- (void)initSettings
{
    if (_mSIPInitialized == NO) {
        return;
    }
    
    [_mPortSipSDK enableAEC:_checkboxAEC.state];
    
    [_mPortSipSDK enableVAD:_checkboxVAD.state];
    
    [_mPortSipSDK enableCNG:_checkboxCNG.state];
    
    [_mPortSipSDK enableAGC:_checkboxAGC.state];
    
    [_mPortSipSDK enableANS:_checkboxANS.state];
    
    [_mPortSipSDK setVideoNackStatus:_checkboxNACK.state];
    
    [_mPortSipSDK setDoNotDisturb:_checkboxDND.state];
}

- (void)updateVideoCodecs
{
    if (_mSIPInitialized == NO) {
        return;
    }
    
    [_mPortSipSDK clearVideoCodec];
    
    if (_checkboxH264.state) {
        [_mPortSipSDK addVideoCodec:VIDEO_CODEC_H264];
    }
    
    if (_checkboxVP8.state) {
        [_mPortSipSDK addVideoCodec:VIDEO_CODEC_VP8];
    }
    
    if (_checkboxVP9.state) {
        [_mPortSipSDK addVideoCodec:VIDEO_CODEC_VP9];
    }
}

- (void)initDefaultAudioCodecs
{
    if (_mSIPInitialized == NO) {
        return;
    }
    
    [_mPortSipSDK clearAudioCodec];
    
    //Default we just using PCMU, PCMA, G729.
    [_mPortSipSDK addAudioCodec:AUDIOCODEC_PCMU];
    [_mPortSipSDK addAudioCodec:AUDIOCODEC_PCMA];
    [_mPortSipSDK addAudioCodec:AUDIOCODEC_G729];
    
    //for DTMF as RTP Event - RFC2833.
    [_mPortSipSDK addAudioCodec:AUDIOCODEC_DTMF];
}

- (IBAction)onCodec:(id)sender
{
    [self updateAudioCodecs];
    [self updateVideoCodecs];
}

- (void)updateAudioCodecs
{
    if (_mSIPInitialized == NO) {
        return;
    }
    
    [_mPortSipSDK clearAudioCodec];
    
    //PCMU
    if (_checkboxG711ulaw.state) {
        [_mPortSipSDK addAudioCodec:AUDIOCODEC_PCMU];
    }
    
    //PCMA
    if (_checkboxG711alaw.state){
        [_mPortSipSDK addAudioCodec:AUDIOCODEC_PCMA];
    }
    
    if (_checkboxG729.state) {
        [_mPortSipSDK addAudioCodec:AUDIOCODEC_G729];
    }
    
    if (_checkboxILBC.state) {
        [_mPortSipSDK addAudioCodec:AUDIOCODEC_ILBC];
    }
    
    if (_checkboxGSM.state) {
        [_mPortSipSDK addAudioCodec:AUDIOCODEC_GSM];
    }
    
    if (_checkboxAMR.state) {
        [_mPortSipSDK addAudioCodec:AUDIOCODEC_AMR];
    }
    
    if (_checkboxG722.state) {
        [_mPortSipSDK addAudioCodec:AUDIOCODEC_G722];
    }
    
    if (_checkboxSPEEX.state) {
        [_mPortSipSDK addAudioCodec:AUDIOCODEC_SPEEX];
    }
    
    if (_checkboxAMRWB.state) {
        [_mPortSipSDK addAudioCodec:AUDIOCODEC_AMRWB];
    }
    
    if (_checkboxSPEEXWB.state) {
        [_mPortSipSDK addAudioCodec:AUDIOCODEC_SPEEXWB];
    }
    
    if (_checkboxG7221.state) {
        [_mPortSipSDK addAudioCodec:AUDIOCODEC_G7221];
    }
    
    if (_checkboxOpus.state) {
        [_mPortSipSDK addAudioCodec:AUDIOCODEC_OPUS];
    }
    
    [_mPortSipSDK addAudioCodec:AUDIOCODEC_DTMF];
}

- (void)setVideoQuality
{
    if (_mSIPInitialized == NO) {
        return;
    }
    
    [_mPortSipSDK setVideoBitrate:-1 bitrateKbps:_sliderQuality.floatValue];
}

- (void)onOptions
{
    if (_mSIPInitialized == NO) {
        return;
    }
    
    NSString *uniqueId = @"";
    NSString *deviceName = @"";
    
    int ret = [_mPortSipSDK getVideoCaptureDeviceName:(int)_comboboxCameara.indexOfSelectedItem uniqueId:&uniqueId deviceName:&deviceName];
    if (ret != 0) {
        [self showAlertWithText:@"Failed to get camera name."];
        return;
    }
}

- (void)setVideoResolution
{
    if (_mPortSipSDK == NO) {
        return;
    }
    
    int width = 352;
    int height = 288;
    
    switch (_comboboxResolution.indexOfSelectedItem) {
        case 0:
            width = 176;
            height = 144;
            break;
        case 1:
            width = 352;
            height = 288;
            break;
        case 2:
            width = 640;
            height = 480;
            break;
        case 3:
            width = 800;
            height = 600;
            break;
        case 4:
            width = 1024;
            height = 768;
            break;
        case 5:
            width = 1280;
            height = 720;
            break;
        case 6:
            width = 320;
            height = 240;
            break;
        default:
            break;
    }
    
    [_mPortSipSDK setVideoResolution:width height:height];
}

- (void)setSRTPType
{
    if (_mSIPInitialized == NO) {
        return;
    }
    
    SRTP_POLICY SRTPPolicy = SRTP_POLICY_NONE;
    
    switch (_comboboxSRTP.indexOfSelectedItem) {
        case 0:
            SRTPPolicy = SRTP_POLICY_NONE;
            break;
        case 1:
            SRTPPolicy = SRTP_POLICY_FORCE;
            break;
        case 2:
            SRTPPolicy = SRTP_POLICY_PREFER;
            break;
        default:
            break;
    }
    [_mPortSipSDK setSrtpPolicy:SRTPPolicy];
}

- (void)loadDevices{
    if (_mSIPInitialized == false) {
        return;
    }
    
    int num = [_mPortSipSDK getNumOfPlayoutDevices];
    
    for (int i = 0; i < num; ++i) {
        NSString *deviceName = nil;
        deviceName = [_mPortSipSDK getPlayoutDeviceName:i];
        if (deviceName) {
            [_comboboxSpeaker addItemWithObjectValue:deviceName];
        }
    }
    
    if (num > 0) {
        [_comboboxSpeaker selectItemAtIndex:0];
    }
    
    num = [_mPortSipSDK getNumOfRecordingDevices];
    
    for (int i = 0; i < num; ++i) {
        NSString *deviceName = nil;
        deviceName = [_mPortSipSDK getRecordingDeviceName:i];
        if (deviceName) {
            [_comboboxMicrophone addItemWithObjectValue:deviceName];
        }
    }
    
    if (num > 0) {
        [_comboboxMicrophone selectItemAtIndex:0];
    }
    
    
    num = [_mPortSipSDK getNumOfVideoCaptureDevices];
    
    for (int i = 0; i < num; ++i) {
        NSString *uniqueId = nil;
        NSString *deviceName = nil;
        if (![_mPortSipSDK getVideoCaptureDeviceName:i uniqueId:&uniqueId deviceName:&deviceName]) {
            [_comboboxCameara addItemWithObjectValue:deviceName];
        }
    }
    
    if (num > 0) {
        [_comboboxCameara selectItemAtIndex:0];
    }
    
    int volume = [_mPortSipSDK getSpeakerVolume];
    [_sliderSpeaker setFloatValue:volume];
    
    volume = [_mPortSipSDK getMicVolume];
    [_sliderMicrophone setFloatValue:volume];
}

#pragma mark - DeRegister
- (void)deRegisterFromServer
{
    if (_mSIPInitialized == NO) {
        return;
    }
    
    for (int i = LINE_BASE; i < MAX_LINES; ++i) {
        if (mSessionArray[i].recvCallState == true) {
            [_mPortSipSDK rejectCall:mSessionArray[i].sessionId code:486];
        }else if (mSessionArray[i].sessionState == true){
            [_mPortSipSDK hangUp:mSessionArray[i].sessionId];
        }
        
        [mSessionArray[i] reset];
    }
    
    if (self.sipRegistrationStatus == LOGIN_STATUS_REGISTERING
        || self.sipRegistrationStatus == LOGIN_STATUS_ONLINE) {
        [_mPortSipSDK unRegisterServer];
        self.sipRegistrationStatus = LOGIN_STATUS_OFFLINE;
    }
    
    if (_mSIPInitialized) {
        [_mPortSipSDK unInitialize];
        _mSIPInitialized = NO;
    }
    
    [_uiviewLocal releaseVideoRender];
    [_uiviewRemote releaseVideoRender];
    
    //[_logData removeAllObjects];
    [self.tableViewLog reloadData];
    
    [_comboboxLines selectItemAtIndex:0];
    _mCurrentlyLine = LINE_BASE;
    
    [_comboboxSpeaker removeAllItems];
    [_comboboxMicrophone removeAllItems];
    [_comboboxCameara removeAllItems];
}

#pragma mark - Changed the call lines
- (void)linesSelectedIndexChanged
{
    if (_mSIPInitialized == NO || (_checkboxRegisterToServer.state && (self.sipRegistrationStatus != LOGIN_STATUS_ONLINE))) {
        [_comboboxLines selectItemAtIndex:0];
        return;
    }
    
    if (_mCurrentlyLine == (_comboboxLines.indexOfSelectedItem + LINE_BASE)) {
        return;
    }
    
    if (_checkboxConference.state) {
        _mCurrentlyLine = (_comboboxLines.indexOfSelectedItem + LINE_BASE);
        return;
    }
    
    //To switch the line, must hold currently line first
    if (mSessionArray[_mCurrentlyLine].sessionState == YES && mSessionArray[_mCurrentlyLine].holdState == NO) {
        [_mPortSipSDK hold:mSessionArray[_mCurrentlyLine].sessionId];
        [mSessionArray[_mCurrentlyLine] setHoldState:YES];
        
        [_mPortSipSDK setRemoteVideoWindow:mSessionArray[_mCurrentlyLine].sessionId remoteVideoWindow:nil];
        [self addLineStringToTableView:[NSString stringWithFormat:@"Line %ld : Hold", _mCurrentlyLine]];
    }
    
    _mCurrentlyLine = (_comboboxLines.indexOfSelectedItem + LINE_BASE);
    
    //If target line wwas in hold state, then un-hold it
    if (mSessionArray[_mCurrentlyLine].sessionState == YES && mSessionArray[_mCurrentlyLine].holdState == YES) {
        [_mPortSipSDK unHold:mSessionArray[_mCurrentlyLine].sessionId];
        [mSessionArray[_mCurrentlyLine] setHoldState:NO];
        
        [_mPortSipSDK setRemoteVideoWindow:mSessionArray[_mCurrentlyLine].sessionId remoteVideoWindow:_uiviewRemote];
        [self addLineStringToTableView:[NSString stringWithFormat:@"Line %ld : UnHold - call established.", _mCurrentlyLine]];
    }
}


- (void)enterNumericKey:(NSString *)key
{
    [self.textFieldPhonenumber setStringValue:[NSString stringWithFormat:@"%@%@", _textFieldPhonenumber.stringValue, key]];
}

- (void)sendDtmf:(int)code
{
    if (_mSIPInitialized == YES && mSessionArray[_mCurrentlyLine].sessionState == YES) {
        [_mPortSipSDK sendDtmf:mSessionArray[_mCurrentlyLine].sessionId dtmfMethod:DTMF_RFC2833 code:code dtmfDration:160 playDtmfTone:YES];
    }
}

- (void)onConference
{
    if (_mSIPInitialized == false || (_checkboxRegisterToServer.state && (self.sipRegistrationStatus != LOGIN_STATUS_ONLINE))) {
        _checkboxConference.state = NO;
        return;
    }
    
    int width = 352;
    int height = 288;
    
    switch (_comboboxResolution.indexOfSelectedItem) {
        case 0:
            width = 176;
            height = 144;
            break;
        case 1:
            width = 352;
            height = 288;
            break;
        case 2:
            width = 640;
            height = 480;
            break;
        case 3:
            width = 800;
            height = 600;
            break;
        case 4:
            width = 1024;
            height = 768;
            break;
        case 5:
            width = 1280;
            height = 720;
            break;
        case 6:
            width = 320;
            height = 240;
            break;
        default:
            break;
    }
    
    [_mPortSipSDK setVideoResolution:width height:height];
    
    if (_checkboxConference.state) {
        [self createConference:width height:height];
    }else{
        [self destoryConference];
    }
}

- (void)createConference:(int)width height:(int)height
{
    int ret = [_mPortSipSDK createVideoConference:_uiviewRemote videoWidth:width videoHeight:height displayLocalVideo:NO];
    if (ret == 0) {
        [self addLineStringToTableView:@"Make conference succeded."];
        for (int i = LINE_BASE; i < MAX_LINES; ++i) {
            if (mSessionArray[i].sessionState) {
                [self joinConference:i];
            }
        }
    }else{
        [self addLineStringToTableView:@"Failed to create confernece."];
        _checkboxConference.state = NO;
    }
}

- (void)joinConference:(long)index
{
    if (_mSIPInitialized == NO) {
        return;
    }
    
    if (_checkboxConference.state == NO) {
        return;
    }
    [_mPortSipSDK joinToConference:mSessionArray[index].sessionId];
    if (mSessionArray[index].holdState) {
        [_mPortSipSDK unHold:mSessionArray[index].sessionId];
        [mSessionArray[index] setHoldState:NO];
    }
    [_mPortSipSDK setRemoteVideoWindow:mSessionArray[index].sessionId remoteVideoWindow:nil];
}

- (void)destoryConference
{
    for (int i = LINE_BASE; i < MAX_LINES; ++i) {
        if (i != _mCurrentlyLine && mSessionArray[i].sessionState && mSessionArray[i].holdState == false) {
            [_mPortSipSDK hold:mSessionArray[i].sessionId];
            [mSessionArray[i] setHoldState:YES];
        }
    }
    
    [_mPortSipSDK destroyConference];
    [_mPortSipSDK setRemoteVideoWindow:mSessionArray[_mCurrentlyLine].sessionId remoteVideoWindow:_uiviewRemote];
    [self addLineStringToTableView:@"Taken off Conference"];
}

- (void)makeCall
{
    if (_mSIPInitialized == NO || (_checkboxRegisterToServer.state && (self.sipRegistrationStatus != LOGIN_STATUS_ONLINE))) {
        return;
    }
    
    if (_textFieldPhonenumber.stringValue.length <= 0) {
        [self showAlertWithText:@"The phone number is empty."];
        return;
    }
    
    if (mSessionArray[_mCurrentlyLine].sessionState == YES || mSessionArray[_mCurrentlyLine].recvCallState == YES) {
        [self showAlertWithText:@"Current line is busy now, please switch a line."];
        return;
    }
    
    NSString *callTo = self.textFieldPhonenumber.stringValue;
    
    [self updateAudioCodecs];
    [self updateVideoCodecs];
    
    // Ensure the we have been added one audio codec at least
    if ([_mPortSipSDK isAudioCodecEmpty] == YES) {
        [self initDefaultAudioCodecs];
    }
    
    //Usually for 3PCC need to make call without SDP
    BOOL hasSdp = !_checkboxSDP.state;
    
    [_mPortSipSDK setAudioDeviceId:(int)_comboboxMicrophone.indexOfSelectedItem outputDeviceId:(int)_comboboxSpeaker.indexOfSelectedItem];
    
    long sessionId = [_mPortSipSDK call:callTo sendSdp:hasSdp videoCall:_checkboxMakevideocall.state];
    
    if (sessionId <= 0) {
        [self addLineStringToTableView:[NSString stringWithFormat:@"Call failure"]];
    }
    
    [_mPortSipSDK setRemoteVideoWindow:sessionId remoteVideoWindow:_uiviewRemote];
    
    [mSessionArray[_mCurrentlyLine] setSessionId:sessionId];
    [mSessionArray[_mCurrentlyLine] setSessionState:YES];
    
    [self addLineStringToTableView:[NSString stringWithFormat:@"Line %ld : Calling...", _mCurrentlyLine]];
}

- (void)answerCall
{
    if (_mSIPInitialized == NO || (_checkboxRegisterToServer.state && (self.sipRegistrationStatus != LOGIN_STATUS_ONLINE))) {
        return;
    }
    
    if (mSessionArray[_mCurrentlyLine].recvCallState == NO) {
        [self showAlertWithText:[NSString stringWithFormat:@"No incoming call on current line, please switch a line"]];
        return;
    }
    
    [mSessionArray[_mCurrentlyLine] setRecvCallState:NO];
    [mSessionArray[_mCurrentlyLine] setSessionState:YES];
    
    [_mPortSipSDK setRemoteVideoWindow:mSessionArray[_mCurrentlyLine].sessionId remoteVideoWindow:_uiviewRemote];
    
    int ret = [_mPortSipSDK answerCall:mSessionArray[_mCurrentlyLine].sessionId videoCall:_checkboxAnswervideocall.state];
    
    if (ret == 0) {
        [self addLineStringToTableView:[NSString stringWithFormat:@"Line %ld : Call established", _mCurrentlyLine]];
        
        [_mPortSipSDK sendVideo:mSessionArray[_mCurrentlyLine].sessionId sendState:YES];
        [self joinConference:_mCurrentlyLine];
    }
    else
    {
        [mSessionArray[_mCurrentlyLine] reset];
        [self addLineStringToTableView:[NSString stringWithFormat:@"Line %ld : failed to answer call !", _mCurrentlyLine]];
    }
    
}

- (void)holdCall
{
    if (_mSIPInitialized == NO || (_checkboxRegisterToServer.state && (_mSIPInitialized == NO))) {
        return;
    }
    
    if (mSessionArray[_mCurrentlyLine].sessionState == false || mSessionArray[_mCurrentlyLine].holdState == YES) {
        return;
    }
    
    if (_checkboxConference.state) {
        [self holdAllCall];
        return;
    }
    
    int ret = [_mPortSipSDK hold:mSessionArray[_mCurrentlyLine].sessionId];
    
    if (ret != 0) {
        [self addLineStringToTableView:[NSString stringWithFormat:@"Line %ld : hold failure.", _mCurrentlyLine]];
        return;
    }
    
    [mSessionArray[_mCurrentlyLine] setHoldState:YES];
    [self addLineStringToTableView:[NSString stringWithFormat:@"Line %ld : hold", _mCurrentlyLine]];
}

- (void)holdAllCall
{
    for (int i = LINE_BASE; i < MAX_LINES; ++i) {
        if (mSessionArray[i].sessionState && mSessionArray[i].holdState == NO) {
            [_mPortSipSDK hold:mSessionArray[i].sessionId];
            [mSessionArray[i] setHoldState:YES];
        }
    }
    [self addLineStringToTableView:@"Hold all call..."];
}

- (void)onTransfer:(id)sender
{
    if (_mSIPInitialized == NO || (_checkboxRegisterToServer.state && (self.sipRegistrationStatus != LOGIN_STATUS_ONLINE))) {
        return;
    }
    
    if (mSessionArray[_mCurrentlyLine].sessionState == false) {
        [self showAlertWithText:[NSString stringWithFormat:@"Need to make the call established first"]];
    }
    
    self.transfer = [[MLTransferWindowController alloc] initWithWindowNibName:@"MLTransferWindowController"];
    self.transfer.transferDelegate = self;
    
    transferType = TransferType_Transfer;
    
    [[sender window] beginSheet:self.transfer.window completionHandler:^(NSModalResponse returnCode){
      //your code
    }];
}

- (void)attendTransfer:(id)sender
{
    if (_mSIPInitialized == NO || (_checkboxRegisterToServer.state && (self.sipRegistrationStatus != LOGIN_STATUS_ONLINE))) {
        return;
    }
    
    if (mSessionArray[_mCurrentlyLine].sessionState == false) {
        [self showAlertWithText:[NSString stringWithFormat:@"Need to make the call established first"]];
    }
    
    self.transfer = [[MLTransferWindowController alloc] initWithWindowNibName:@"MLTransferWindowController"];
    self.transfer.transferDelegate = self;
    
    transferType = TransferType_AttendTransfer;
    
    [[sender window] beginSheet:self.transfer.window completionHandler:^(NSModalResponse returnCode){
      //your code
    }];
}

- (void)onTransfer:(NSString *)transferTo withLine:(NSInteger)line
{
    if (transferTo.length <= 0) {
        [self showAlertWithText:@"The transfer number is empty."];
        return;
    }
    
    if (transferType == TransferType_Transfer)
    {
        int ret = [_mPortSipSDK refer:mSessionArray[_mCurrentlyLine].sessionId referTo:transferTo];
        
        [self addLineStringToTableView:[NSString stringWithFormat:@"Line %ld : %@", _mCurrentlyLine,  ret == 0 ? @"Transferring" : @"failed to Transfer"]];

    }
    else if (transferType == TransferType_AttendTransfer)
    {
        
        if (line < LINE_BASE || line >= MAX_LINES) {
            [self showAlertWithText:@"The replace line out of range."];
            return;
        }
        
        if (mSessionArray[line].sessionState == false) {
            [self showAlertWithText:@"The replace line does not established yet."];
            return;
        }
        
        int ret = [_mPortSipSDK attendedRefer:mSessionArray[_mCurrentlyLine].sessionId replaceSessionId:mSessionArray[line].sessionId referTo:transferTo];
        
        [self addLineStringToTableView:[NSString stringWithFormat:@"Line %ld : %@", _mCurrentlyLine, ret == 0 ? @"Transferring" : @"failed to Attend transfer"]];
    }
    
    transferType = TransferType_None;
}

- (void)hangUp
{
    if (_mSIPInitialized == NO || (_checkboxRegisterToServer.state && (self.sipRegistrationStatus != LOGIN_STATUS_ONLINE))) {
        return;
    }
    
    if (mSessionArray[_mCurrentlyLine].recvCallState == YES) {
        [_mPortSipSDK rejectCall:mSessionArray[_mCurrentlyLine].sessionId code:486];
        [mSessionArray[_mCurrentlyLine] reset];
        
        [self addLineStringToTableView:[NSString stringWithFormat:@"Line %ld : Rejected call", _mCurrentlyLine]];
        
        return;
    }
    
    if (mSessionArray[_mCurrentlyLine].sessionState == YES) {
        [_mPortSipSDK hangUp:mSessionArray[_mCurrentlyLine].sessionId];
        [mSessionArray[_mCurrentlyLine] reset];
        
        [self addLineStringToTableView:[NSString stringWithFormat:@"Line %ld : Hang up", _mCurrentlyLine]];
        return;
    }
}

- (void)rejectCall
{
    if (_mSIPInitialized == NO || (_checkboxRegisterToServer.state && (self.sipRegistrationStatus != LOGIN_STATUS_ONLINE))) {
        return;
    }
    
    if (mSessionArray[_mCurrentlyLine].recvCallState == YES) {
        [_mPortSipSDK rejectCall:mSessionArray[_mCurrentlyLine].sessionId code:486];
        [mSessionArray[_mCurrentlyLine] reset];
        
        [self addLineStringToTableView:[NSString stringWithFormat:@"Line %ld : Rejected call", _mCurrentlyLine]];
        return;
    }
}

- (void)unHoldCall
{
    if (_mSIPInitialized == NO || (_checkboxRegisterToServer.state && (self.sipRegistrationStatus != LOGIN_STATUS_ONLINE))) {
        return;
    }
    
    if (mSessionArray[_mCurrentlyLine].sessionState == NO || mSessionArray[_mCurrentlyLine].holdState == NO) {
        return;
    }
    
    if (_checkboxConference.state) {
        [self unHoldAllCall];
        return;
    }
    
    int ret = [_mPortSipSDK unHold:mSessionArray[_mCurrentlyLine].sessionId];
    
    if (ret != 0) {
        [mSessionArray[_mCurrentlyLine] setHoldState:false];
        [self addLineStringToTableView:[NSString stringWithFormat:@"Line %ld : Un-Hold Failure.", _mCurrentlyLine]];
        return;
    }
    
    [mSessionArray[_mCurrentlyLine] setHoldState:NO];
    
    [self addLineStringToTableView:[NSString stringWithFormat:@"Line %ld : Un-Hold.", _mCurrentlyLine]];
}

- (void)unHoldAllCall
{
    for (int i = LINE_BASE; i < MAX_LINES; ++i) {
        if (mSessionArray[i].sessionState && mSessionArray[i].holdState == YES) {
            [_mPortSipSDK unHold:mSessionArray[i].sessionId];
            [mSessionArray[i] setHoldState:NO];
        }
    }
    [self addLineStringToTableView:@"unHold all call..."];
}

- (void)onLocalVideo
{
    if (_mSIPInitialized == NO) {
        return;
    }
    
    if ([_buttonLocalVideo.title isEqualToString:@"LocalVideo"]) {
        [_mPortSipSDK displayLocalVideo:YES mirror:YES localVideoWindow:_uiviewLocal];
        _buttonLocalVideo.title = @"StopLocal";
    }else{
        [_mPortSipSDK displayLocalVideo:NO  mirror:NO localVideoWindow:nil];
        _buttonLocalVideo.title = @"LocalVideo";
    }
}

- (void)sendVideo
{
    if (_mSIPInitialized == NO) {
        return;
    }
    
    if (mSessionArray[_mCurrentlyLine].sessionState == NO) {
        return;
    }
    
    int ret = [_mPortSipSDK sendVideo:mSessionArray[_mCurrentlyLine].sessionId sendState:YES];
    if (ret != 0) {
        [self showAlertWithText:@"Start video sending failed."];
    }
}

- (void)stopVideo
{
    if (_mSIPInitialized == NO) {
        return;
    }
    
    if (mSessionArray[_mCurrentlyLine].sessionState == NO) {
        return;
    }
    
    int ret = [_mPortSipSDK sendVideo:mSessionArray[_mCurrentlyLine].sessionId sendState:NO];
    if (ret != 0) {
        [self showAlertWithText:@"Stop video sending failed."];
    }
}

- (void)speakVolumnChanged
{
    if (_mSIPInitialized == NO) {
        return;
    }
    
    int ret = [_mPortSipSDK setSpeakerVolume:_sliderSpeaker.intValue];
    if (ret == 0) {
        MLLog(@"SpeakerVolume : %d", _sliderSpeaker.intValue);
    }else{
        MLLog(@"set SpeakerVolume failed");
    }
}

- (void)microphoneVolumnChanged
{
    if (_mSIPInitialized == NO) {
        return;
    }
    
    int ret = [_mPortSipSDK setMicVolume:_sliderMicrophone.intValue];
    if (ret == 0) {
        MLLog(@"MicVolume : %d", _sliderMicrophone.intValue);
    }else{
        MLLog(@"set Micvolume failed.");
    }
}

- (void)checkMuteMicrophone
{
    if (_mSIPInitialized == NO) {
        return;
    }
    [_mPortSipSDK muteMicrophone:_checkboxMuteMicrophone.state];
}

- (void)switchMicrophoneDevice
{
    if (_mSIPInitialized == NO) {
        return;
    }
    int ret = [_mPortSipSDK setAudioDeviceId:(int)_comboboxMicrophone.indexOfSelectedItem outputDeviceId:(int)_comboboxSpeaker.indexOfSelectedItem];
    if (ret == 0) {
        
    }else{
        
    }
}

- (void)switchSpeakerDevice
{
    if (_mSIPInitialized == NO) {
        return;
    }
    int ret = [_mPortSipSDK setAudioDeviceId:(int)_comboboxMicrophone.indexOfSelectedItem outputDeviceId:(int)_comboboxSpeaker.indexOfSelectedItem];
    if (ret == 0) {
        
    }else{
        
    }
}

- (void)switchCameraDevice
{
    if (_mSIPInitialized == NO) {
        return;
    }
    int ret = [_mPortSipSDK setVideoDeviceId:(int)_comboboxCameara.indexOfSelectedItem];
    if (ret == 0) {
        
    }else{
        
    }
}

- (void)openDirectory:(BOOL)direc withFile:(BOOL)file withSender:(id)sender
{
    NSTextField *textField = (NSTextField*)sender;
    
    NSOpenPanel *openPanel = [NSOpenPanel openPanel];
    [openPanel setPrompt:@"Choose"];
    [openPanel setMessage:@"Choose a directory save record file:"];
    [openPanel setTitle:@"Choose Directory"];
    [openPanel setCanChooseDirectories:direc];
    [openPanel setCanChooseFiles:file];
    
    // default location is the user's Movies folder
    NSArray *picturesDirectory = NSSearchPathForDirectoriesInDomains(NSMoviesDirectory, NSUserDomainMask, YES);
    [openPanel setDirectoryURL:[NSURL fileURLWithPath:[picturesDirectory objectAtIndex:0]]];
    
    NSInteger result = [openPanel runModal];
    if (result == NSModalResponseOK) {
        NSString *path = [[[openPanel URLs] objectAtIndex:0] path];
        [textField setStringValue:path];
    }
}

- (void)onAudioStream
{
    if (_mSIPInitialized == NO) {
        [self showAlertWithText:@"Please initialize the SDK first."];
        return;
    }
    
    if (_checkboxAudioStreamCallback.state) {
        int ret = [_mPortSipSDK enableAudioStreamCallback:mSessionArray[_mCurrentlyLine].sessionId enable:YES callbackMode:DIRECTION_RECV];
        if (ret != 0) {
            [self showAlertWithText:@"Failed to enable the audio stream."];
            _checkboxAudioStreamCallback.state = NO;
        }
    }else{
        //Disable audio stream
        [_mPortSipSDK enableAudioStreamCallback:mSessionArray[_mCurrentlyLine].sessionId enable:NO callbackMode:DIRECTION_RECV];
    }
    
}

- (void)onStartRecord
{
    if (_mSIPInitialized == NO) {
        [self showAlertWithText:@"Please initialize the SDK first."];
        return;
    }
    
    if (_textFieldRecorddirectory.stringValue.length <= 0 || _textFieldRecordFilename.stringValue.length <= 0) {
        [self showAlertWithText:@"The file path or file name is empty."];
        return;
    }
    
    NSString *path = _textFieldRecorddirectory.stringValue;
    NSString *fileName = _textFieldRecordFilename.stringValue;
    
    AUDIO_FILE_FORMAT audioRecordFileFormat = FILEFORMAT_WAVE;
    
    //Start recording
    int ret = [_mPortSipSDK startRecord:mSessionArray[_mCurrentlyLine].sessionId recordFilePath:path recordFileName:fileName appendTimeStamp:YES audioFileFormat:audioRecordFileFormat audioRecordMode:RECORD_BOTH aviFileCodecType:VIDEO_CODEC_H264 videoRecordMode:RECORD_RECV];
    if (ret != 0) {
        [self showAlertWithText:@"Failed to start record conversation."];
        return;
    }
    
    [self showAlertWithText:@"Started record conversation."];
}

- (void)onStopRecord
{
    if (_mSIPInitialized == NO) {
        return;
    }
    
    int ret = [_mPortSipSDK stopRecord:mSessionArray[_mCurrentlyLine].sessionId];
    if (ret == 0) {
        [self showAlertWithText:@"Stop record conversation."];
    }else{
        [self showAlertWithText:@"Stop record conversation failed."];
    }
}

- (void)onStartPlay
{
    if (_mSIPInitialized == NO) {
        [self showAlertWithText:@"Please initialize the SDK first."];
        return;
    }
    
    if (_textFieldPlayFilename.stringValue.length <= 0) {
        [self showAlertWithText:@"The play file is empty."];
        return;
    }
    
    NSString *playFile = _textFieldPlayFilename.stringValue;
    
    [_mPortSipSDK playAudioFileToRemote:mSessionArray[_mCurrentlyLine].sessionId filename:playFile fileSamplesPerSec:16000 loop:NO];
}

- (void)onStopPlay
{
    if (_mSIPInitialized == NO) {
        return;
    }
    
    [_mPortSipSDK stopPlayAudioFileToRemote:mSessionArray[_mCurrentlyLine].sessionId];
}

- (void)onForwardEnable
{
    if (_mSIPInitialized == NO) {
        [self showAlertWithText:@"Please initialize the SDK first."];
        return;
    }
    
    NSString *forwardTo = _textFieldForward.stringValue;
    NSRange range = [forwardTo rangeOfString:kRegularExp options:NSRegularExpressionSearch];
    if (range.location == NSNotFound) {
        [self showAlertWithText:@"The phone number must likes <sip:123456@192.168.1.111>"];
        return;
    }
    
    if (_checkboxForward.state) {
        [_mPortSipSDK enableCallForward:YES forwardTo:forwardTo];
    }else{
        [_mPortSipSDK enableCallForward:NO forwardTo:forwardTo];
    }
    
    [self showAlertWithText:@"The call forward is enabled."];
}

- (void)onForwardDisable
{
    if (_mSIPInitialized == NO) {
        [self showAlertWithText:@"Please initialize the SDK first."];
        return;
    }
    
    [_mPortSipSDK disableCallForward];
    
    [self showAlertWithText:@"The Call forward is disabled."];
}

- (IBAction)onEnableEffect:(id)sender
{
    if (_mSIPInitialized == NO) {
        return;
    }
    
    if (sender == _checkboxAEC)
    {
        [_mPortSipSDK enableAEC:_checkboxAEC.state];
    }
    else if (sender == _checkboxVAD)
    {
        [_mPortSipSDK enableVAD:_checkboxVAD.state];
    }
    else if (sender == _checkboxCNG)
    {
        [_mPortSipSDK enableCNG:_checkboxCNG.state];
    }
    else if (sender == _checkboxAGC)
    {
        [_mPortSipSDK enableAGC:_checkboxAGC.state];
    }
    else if (sender == _checkboxANS)
    {
        [_mPortSipSDK enableANS:_checkboxANS.state];
    }
    else if (sender == _checkboxNACK)
    {
        [_mPortSipSDK setVideoNackStatus:_checkboxNACK.state];
    }

}

- (IBAction)sendEmail:(id)sender {
    NSSharingService *service = [NSSharingService sharingServiceNamed:NSSharingServiceNameComposeEmail];
    service.recipients = [NSArray arrayWithObjects:@"sales@portsip.com", nil];
    service.subject = @"PortSIP VoIP SDK for MAC";
    NSArray *shareItems =@[@"I am interested in the PortSIP VoIP SDK for MAC"];
    [service performWithItems:shareItems];
}

- (IBAction)onNumericKey:(id)sender
{
    NSButton *btn = (NSButton*)sender;
    [self enterNumericKey:btn.title];
    [self sendDtmf:(int)btn.tag];
}

#pragma mark - Button Event
- (IBAction)onButtonClick:(id)sender {
    
    //Login
    if (sender == _comboboxSRTP)
    {
        [self setSRTPType];
    }
    else if (sender == _buttonOnline)
    {
        NSString* error;
        if (_mSIPInitialized == YES) {
            error = @"You are already logged in.";
        }else{
            error = [self accoutValidate];
        }
        if(error==nil){
            [self registerToServer:true];
        }else{
            [self showAlertWithText:error];
        }
        
    }
    else if (sender == _buttonOffline)
    {
        [self deRegisterFromServer];
    }
    //Call
    else if (sender == _comboboxLines)
    {
        [self linesSelectedIndexChanged];
    }
    else if (sender == _checkboxPackage)
    {
        [self updatePrackSetting];
    }
    else if (sender == _checkboxDND)
    {
        [self checkDND];
    }
    else if (sender == _checkboxConference)
    {
        [self onConference];
    }
    else if (sender == _buttonDial)
    {
        [self makeCall];
    }
    else if (sender == _buttonAnswer)
    {
        [self answerCall];
    }
    else if (sender == _buttonHold)
    {
        [self holdCall];
    }
    else if (sender == _buttonTransfer)
    {
        [self onTransfer:sender];
    }
    else if (sender == _buttonHangup)
    {
        [self hangUp];
    }
    else if (sender == _buttonReject)
    {
        [self rejectCall];
    }
    else if (sender == _buttonUnhold)
    {
        [self unHoldCall];
    }
    else if (sender == _buttonAttendtransfer)
    {
        [self attendTransfer:sender];
    }
    //video
    else if (sender == _comboboxResolution)
    {
        [self setVideoResolution];
    }
    else if (sender == _sliderQuality)
    {
        [self setVideoQuality];
    }
    else if (sender == _buttonOptions)
    {
        [self onOptions];
    }
    else if (sender == _buttonLocalVideo)
    {
        [self onLocalVideo];
    }
    else if (sender == _buttonSendvideo)
    {
        [self sendVideo];
    }
    else if (sender == _buttonStopvideo)
    {
        [self stopVideo];
    }
    //Log
    else if (sender == _buttonClear)
    {
        [_logData removeAllObjects];
        [self.tableViewLog reloadData];
    }
    //Audio
    else if (sender == _sliderSpeaker)
    {
        [self speakVolumnChanged];
    }
    else if (sender == _sliderMicrophone)
    {
        [self microphoneVolumnChanged];
    }
    else if (sender == _checkboxMuteMicrophone)
    {
        [self checkMuteMicrophone];
    }
    else if (sender == _comboboxMicrophone)
    {
        [self switchMicrophoneDevice];
    }
    else if (sender == _comboboxSpeaker)
    {
        [self switchSpeakerDevice];
    }
    else if (sender == _comboboxCameara)
    {
        [self switchCameraDevice];
    }
    else if (sender == _buttonRecorddirectory)
    {
        [self openDirectory:YES withFile:NO withSender:_textFieldRecorddirectory];
    }
    else if (sender == _checkboxAudioStreamCallback)
    {
        [self onAudioStream];
    }
    else if (sender == _buttonStartRecord)
    {
        [self onStartRecord];
    }
    else if (sender == _buttonStopRecord)
    {
        [self onStopRecord];
    }
    else if (sender == _buttonPlayFile)
    {
        [self openDirectory:NO withFile:YES withSender:_textFieldPlayFilename];
    }
    else if (sender == _buttonStartPlay)
    {
        [self onStartPlay];
    }
    else if (sender == _buttonStopPlay)
    {
        [self onStopPlay];
    }
    else if (sender == _buttonForwardEnable)
    {
        [self onForwardEnable];
    }
    else if (sender == _buttonForwardDisable)
    {
        [self onForwardDisable];
    }
}

#pragma mark - PortSipSdk
- (void)onRegisterSuccess:(char*) statusText
               statusCode:(int)statusCode
               sipMessage:(char*)sipMessage
{
    [self addLineStringToTableView:@"Registration succeeded."];
    
    self.sipRegistrationStatus = LOGIN_STATUS_ONLINE;
    return;
}


- (void)onRegisterFailure:(char*) statusText
               statusCode:(int)statusCode
               sipMessage:(char*)sipMessage
{
    [self addLineStringToTableView:[@"Registration failure." stringByAppendingFormat:@"%s",statusText]];
    
    self.sipRegistrationStatus = LOGIN_STATUS_FAILUE;
    if(statusCode != 401 && statusCode != 403 && statusCode != 404){
        if([self accoutValidate]==nil){
            
            //If the NetworkStatus not change, received onRegisterFailure event. can added a atuo reRegister Timer like this:
            // added a atuo reRegister Timer
            int interval = mAutoRegisterRetryTimes * 2 + 1;
            //max interval is 60
            interval = interval > 60?60:interval;
            mAutoRegisterRetryTimes ++;
            mAutoRegisterTimer = [NSTimer scheduledTimerWithTimeInterval:interval target:self selector:@selector(refreshRegister) userInfo:nil repeats:NO];
        }
    }
    return;
}

- (void)onInviteIncoming:(long)sessionId
       callerDisplayName:(char*)callerDisplayName
                  caller:(char*)caller
       calleeDisplayName:(char*)calleeDisplayName
                  callee:(char*)callee
             audioCodecs:(char*)audioCodecs
             videoCodecs:(char*)videoCodecs
             existsAudio:(BOOL)existsAudio
             existsVideo:(BOOL)existsVideo
              sipMessage:(char*)sipMessage
{
    int index = [self getIdelLine];
    
    if (index == -1) {
        [_mPortSipSDK rejectCall:sessionId code:486];
    }
    
    mSessionArray[index].sessionId = sessionId;
    mSessionArray[index].videoState = existsAudio;
    
    BOOL needIgnoreAutoAnswer = [self isAutoAnswer];
    
    BOOL isAutoAnswer = _checkboxAutoanswer.state;
    BOOL isAnswerVideo = _checkboxAnswervideocall.state;
    
    if (needIgnoreAutoAnswer == NO && isAutoAnswer) {
        mSessionArray[index].recvCallState = NO;
        mSessionArray[index].sessionState = YES;
        
        [_mPortSipSDK setRemoteVideoWindow:mSessionArray[index].sessionId remoteVideoWindow:_uiviewRemote];
        
        [_mPortSipSDK answerCall:mSessionArray[index].sessionId videoCall:isAnswerVideo];
        
        [self addLineStringToTableView:[NSString stringWithFormat:@"Line %d : Answered call by Auto answer", index]];
        
        return;
    }
    
    [self addLineStringToTableView:[NSString stringWithFormat:@"Line %d : Call incoming from %s <%s>", index, callerDisplayName, caller]];
    
    return;
}

- (void)onInviteTrying:(long)sessionId
{
    int index = [self findLine:sessionId];
    if (index == -1) {
        return;
    }
    
    [self addLineStringToTableView:[NSString stringWithFormat:@"Line %d : Call is trying...", index]];
    return;
}

- (void)onInviteSessionProgress:(long)sessionId
                    audioCodecs:(char *)audioCodecs
                    videoCodecs:(char *)videoCodecs
               existsEarlyMedia:(BOOL)existsEarlyMedia
                    existsAudio:(BOOL)existsAudio
                    existsVideo:(BOOL)existsVideo
                     sipMessage:(char*)sipMessage
{
    int index = [self findLine:sessionId];
    if (index == -1) {
        return;
    }
    
    [mSessionArray[index] setSessionState:YES];
    
    [self addLineStringToTableView:[NSString stringWithFormat:@"Line %d : Call session progress.", index]];
    
    [mSessionArray[index] setExistEarlyMedia:existsEarlyMedia];
    
    return;
}

- (void) onInviteRinging:(long)sessionId
              statusText:(char *)statusText
              statusCode:(int)statusCode
              sipMessage:(char*)sipMessage
{
    int index = [self findLine:sessionId];
    
    if (index == -1) {
        return;
    }
    
    if (mSessionArray[index].existEarlyMedia == false) {
        // No early media, you must play the local WAVE  file for ringing tone
    }
    
    [self addLineStringToTableView:[NSString stringWithFormat:@"Line %d : Ringing...", index]];
    
    return;
}

- (void)onInviteAnswered:(long)sessionId
       callerDisplayName:(char *)callerDisplayName
                  caller:(char *)caller
       calleeDisplayName:(char *)calleeDisplayName
                  callee:(char *)callee
             audioCodecs:(char *)audioCodecs
             videoCodecs:(char *)videoCodecs
             existsAudio:(BOOL)existsAudio
             existsVideo:(BOOL)existsVideo
              sipMessage:(char*)sipMessage
{
    int index = [self findLine:sessionId];
    
    if (index == -1) {
        return;
    }
    
    if (existsVideo)
    {
        // If more than one codecs using, then they are separated with "#",
        // for example: "g.729#GSM#AMR", "H264#H263", you have to parse them by yourself.
        [_mPortSipSDK sendVideo:sessionId sendState:YES];
    }
    if (existsAudio)
    {
        // If more than one codecs using, then they are separated with "#",
        // for example: "g.729#GSM#AMR", "H264#H263", you have to parse them by yourself.
    }
    
    [mSessionArray[index] setSessionState:YES];
    
    [self addLineStringToTableView:[NSString stringWithFormat:@"Line %d : Call established.", index]];
    
    [self joinConference:index];
    
    if (mSessionArray[index].isReferCall) {
        [mSessionArray[index] setRefer:NO withOriginCallSessionId:0];
    }
    
    return;
}

- (void)onInviteFailure:(long)sessionId
                 reason:(char *)reason
                   code:(int)code
             sipMessage:(char*)sipMessage
{
    int index = [self findLine:sessionId];
    
    if (index == -1) {
        return;
    }
    
    [self addLineStringToTableView:[NSString stringWithFormat:@"Line %d : call failure, %s, %d", index, reason, code]];
    
    if (mSessionArray[index].isReferCall) {
        int originIndex = -1;
        for (int i = LINE_BASE; i < MAX_LINES; ++i) {
            if (mSessionArray[i].sessionId == mSessionArray[index].originCallSessionId) {
                originIndex = i;
                break;
            }
        }
        
        if (originIndex != -1) {
            [_mPortSipSDK unHold:mSessionArray[index].originCallSessionId];
            [mSessionArray[originIndex] setHoldState:NO];
            
            _mCurrentlyLine = originIndex;
            [_comboboxLines selectItemAtIndex:_mCurrentlyLine - 1];
            
            [self addLineStringToTableView:[NSString stringWithFormat:@"Current line is set to : %ld", _mCurrentlyLine]];
        }
    }
    
    [mSessionArray[index] reset];
    
    return;
}

- (void)onInviteUpdated:(long)sessionId
            audioCodecs:(char *)audioCodecs
            videoCodecs:(char *)videoCodecs
           screenCodecs:(char *)screenCodecs
            existsAudio:(BOOL)existsAudio
            existsVideo:(BOOL)existsVideo
           existsScreen:(BOOL)existsScreen
             sipMessage:(char *)sipMessage 
{
    int index = [self findLine:sessionId];
    
    if (index == -1) {
        return;
    }
    
    if (existsVideo)
    {
        // If more than one codecs using, then they are separated with "#",
        // for example: "g.729#GSM#AMR", "H264#H263", you have to parse them by yourself.
    }
    if (existsAudio)
    {
        // If more than one codecs using, then they are separated with "#",
        // for example: "g.729#GSM#AMR", "H264#H263", you have to parse them by yourself.
    }
    
    [self addLineStringToTableView:[NSString stringWithFormat:@"Line %d : Call is updated", index]];
    
    return;
}

- (void)onInviteConnected:(long)sessionId
{
    int index = [self findLine:sessionId];
    if (index == -1) {
        return;
    }
    
    [self addLineStringToTableView:[NSString stringWithFormat:@"Line %d : Call is connected", index]];
    return;
}

- (void)onInviteBeginingForward:(char *)forwardTo
{
    [self addLineStringToTableView:[NSString stringWithFormat:@"An incoming call was forwarded to : %s", forwardTo]];
    
    return;
}


- (void)onInviteClosed:(long)sessionId sipMessage:(char *)sipMessage
{
    int index = [self findLine:sessionId];
    
    if (index == -1) {
        return;
    }
    
    [mSessionArray[index] reset];
    
    [self addLineStringToTableView:[NSString stringWithFormat:@"Line %d : Call closed", index]];
    
    return;
}

-(void)onDialogStateUpdated:(char *)BLFMonitoredUri BLFDialogState:(char *)BLFDialogState BLFDialogId:(char *)BLFDialogId BLFDialogDirection:(char *)BLFDialogDirection
{
    NSLog(@"The user %s dialog state is updated:%s, dialog id: %s, direction: %s ",
          BLFMonitoredUri,BLFDialogState,BLFDialogId,BLFDialogDirection);
}

- (void)onRemoteHold:(long)sessionId
{
    int index = [self findLine:sessionId];
    
    if (index == -1) {
        return;
    }
    
    [self addLineStringToTableView:[NSString stringWithFormat:@"Line %d : Placed on hold by remote.", index]];
    
    return;
}

- (void)onRemoteUnHold:(long)sessionId audioCodecs:(char *)audioCodecs videoCodecs:(char *)videoCodecs existsAudio:(BOOL)existsAudio existsVideo:(BOOL)existsVideo
{
    int index = [self findLine:sessionId];
    if (index == -1) {
        return;
    }
    
    [self addLineStringToTableView:[NSString stringWithFormat:@"Line %d : Take off hold by remote.", index]];
    
    return;
}

- (void)onReceivedRefer:(long)sessionId referId:(long)referId to:(char *)to from:(char *)from referSipMessage:(char *)referSipMessage
{
    int index = [self findLine:sessionId];
    
    if (index == -1) {
        [_mPortSipSDK rejectRefer:referId];
        return;
    }
    
    NSString *msg = [NSString stringWithFormat:@"Received Refer on line %d, refer to %s", index, to];
    [self addLineStringToTableView:msg];
    
    long referSessionId = [_mPortSipSDK acceptRefer:referId referSignaling:[NSString stringWithFormat:@"%s", referSipMessage]];
    
    if (referSessionId <= 0) {
        //Accept refer error
        [self addLineStringToTableView:[NSString stringWithFormat:@"Failed to accept refer on line"]];
    }else{//Accept refer sueecess, hangup original call
        [_mPortSipSDK hangUp:mSessionArray[index].sessionId];
        
        [mSessionArray[index] setSessionId:referSessionId];
        [mSessionArray[index] setSessionState:YES];
        [mSessionArray[index] setRefer:YES withOriginCallSessionId:mSessionArray[index].sessionId];
        
        [self addLineStringToTableView:[NSString stringWithFormat:@"Accepted the refer, new call is trying on line %d", index]];
        
        [_mPortSipSDK setRemoteVideoWindow:referSessionId remoteVideoWindow:_uiviewRemote];
    }
    
    /*Reject refer
    [_mPortSipSDK rejectRefer:referId];
    [self addLineStringToTableView:[NSString stringWithFormat:@"Rejected the refer."]];
    */
    return;
}

- (void)onReferAccepted:(long)sessionId
{
    int index = [self findLine:sessionId];
    if (index == -1) {
        return;
    }
    
    [self addLineStringToTableView:[NSString stringWithFormat:@"Line %d , the refer was accepted.", index]];
    return;
}

- (void)onReferRejected:(long)sessionId reason:(char *)reason code:(int)code
{
    int index = [self findLine:sessionId];
    if (index == -1) {
        return;
    }
    
    [self addLineStringToTableView:[NSString stringWithFormat:@"Line %d, the refer was rejected.", index]];
    
    return;
}

- (void)onTransferTrying:(long)sessionId
{
    int index = [self findLine:sessionId];
    if (index == -1) {
        return;
    }
    
    [self addLineStringToTableView:[NSString stringWithFormat:@"Line %d : transfer trying.", index]];
    return;
}

- (void)onTransferRinging:(long)sessionId
{
    int index = [self findLine:sessionId];
    if (index == -1) {
        return;
    }
    
    [self addLineStringToTableView:[NSString stringWithFormat:@"Line %d : transfer Ringing.", index]];
    return;
}

- (void)onACTVTransferSuccess:(long)sessionId
{
    int index = [self findLine:sessionId];
    if (index == -1) {
        return;
    }
    
    [self addLineStringToTableView:[NSString stringWithFormat:@"Line %d, Transfer succeeded.", index]];
    return;
}

- (void)onACTVTransferFailure:(long)sessionId reason:(char *)reason code:(int)code
{
    int index = [self findLine:sessionId];
    if (index == -1) {
        return;
    }
    
    [self addLineStringToTableView:[NSString stringWithFormat:@"Line %d, transfer failure.", index]];
}

- (void)onReceivedSignaling:(long)sessionId message:(char *)message
{
    // This event will be fired when the SDK received a SIP message
    // you can use signaling to access the SIP message.
    return;
}

- (void)onSendingSignaling:(long)sessionId message:(char *)message
{
    // This event will be fired when the SDK sent a SIP message
    // you can use signaling to access the SIP message.
    return;
}

- (void)onWaitingVoiceMessage:(char *)messageAccount urgentNewMessageCount:(int)urgentNewMessageCount urgentOldMessageCount:(int)urgentOldMessageCount newMessageCount:(int)newMessageCount oldMessageCount:(int)oldMessageCount
{
    [self addLineStringToTableView:[NSString stringWithFormat:@"%s has voice message.", messageAccount]];
    // You can use these parameters to check the voice message count
    
    //  urgentNewMessageCount;
    //  urgentOldMessageCount;
    //  newMessageCount;
    //  oldMessageCount;
    return;
}

- (void)onWaitingFaxMessage:(char *)messageAccount urgentNewMessageCount:(int)urgentNewMessageCount urgentOldMessageCount:(int)urgentOldMessageCount newMessageCount:(int)newMessageCount oldMessageCount:(int)oldMessageCount
{
    [self addLineStringToTableView:[NSString stringWithFormat:@"%s has FAX message.", messageAccount]];
    // You can use these parameters to check the FAX message count
    
    //  urgentNewMessageCount;
    //  urgentOldMessageCount;
    //  newMessageCount;
    //  oldMessageCount;
    return;
}

- (void)onRecvDtmfTone:(long)sessionId tone:(int)tone
{
    int index = [self findLine:sessionId];
    if (index == -1) {
        return;
    }
    
    NSString *DTMFTone = [[NSString alloc] initWithFormat:@"%d", tone];
    switch (tone) {
        case 10:
            DTMFTone = @"*";
            break;
        case 11:
            DTMFTone = @"#";
            break;
        case 12:
            DTMFTone = @"A";
            break;
        case 13:
            DTMFTone = @"B";
            break;
        case 14:
            DTMFTone = @"C";
            break;
        case 15:
            DTMFTone = @"D";
            break;
        case 16:
            DTMFTone = @"FLASH";
            break;
        default:
            break;
    }
    
    [self addLineStringToTableView:[NSString stringWithFormat:@"Received DTMF Tone : %@ on line %d", DTMFTone, index]];
    
    return;
}

- (void)onPresenceRecvSubscribe:(long)subscribeId fromDisplayName:(char *)fromDisplayName from:(char *)from subject:(char *)subject
{
    return;
}

- (void)onPresenceOnline:(char *)fromDisplayName from:(char *)from stateText:(char *)stateText
{
    return;
}

- (void)onPresenceOffline:(char *)fromDisplayName from:(char *)from
{
    return;
}

- (void)onRecvOptions:(char *)optionsMessage
{
    return;
}

- (void)onRecvInfo:(char *)infoMessage
{
    [self showAlertWithText:[NSString stringWithFormat:@"Received a INFO message : %s", infoMessage]];
}

- (void)onRecvNotifyOfSubscription:(long)subscribeId
                     notifyMessage:(char*)notifyMessage
                       messageData:(unsigned char*)messageData
                 messageDataLength:(int)messageDataLength
{
    
}

- (void)onRecvMessage:(long)sessionId mimeType:(char *)mimeType subMimeType:(char *)subMimeType messageData:(unsigned char *)messageData messageDataLength:(int)messageDataLength
{
    int index = [self findLine:sessionId];
    if (index == -1) {
        return;
    }
    
    NSString *mime = [NSString stringWithFormat:@"%s", mimeType];
    NSString *subMime = [NSString stringWithFormat:@"%s", subMimeType];
    if ([mime isEqualToString:@"text"] && [subMime isEqualToString:@"plain"]) {
        [self showAlertWithText:[NSString stringWithFormat:@"Received a MESSAGE message on line %d", index]];
    }else if ([mime isEqualToString:@"application"] && [subMime isEqualToString:@"vnd.3gpp.sms"]){
        
    }else if ([mime isEqualToString:@"application"] && [subMime isEqualToString:@"vnd.3gpp2.sms"]){
        
    }
    return;
}
- (void)onRecvOutOfDialogMessage:(char *)fromDisplayName from:(char *)from toDisplayName:(char *)toDisplayName to:(char *)to mimeType:(char *)mimeType subMimeType:(char *)subMimeType messageData:(unsigned char *)messageData messageDataLength:(int)messageDataLength sipMessage:(char *)sipMessage {
    NSString *mime = [NSString stringWithFormat:@"%s", mimeType];
    NSString *subMime = [NSString stringWithFormat:@"%s", subMimeType];
    if ([mime isEqualToString:@"text"] && [subMime isEqualToString:@"plain"]) {
        [self showAlertWithText:[NSString stringWithFormat:@"Received a message(out of dialog) from %s", from]];
    }else if ([mime isEqualToString:@"application"] && [subMime isEqualToString:@"vnd.3gpp.sms"]){
        
    }else if ([mime isEqualToString:@"application"] && [subMime isEqualToString:@"vnd.3gpp2.sms"]){
        
    }
    return;
}

- (void)onSendMessageSuccess:(long)sessionId messageId:(long)messageId
{
    return;
}

- (void)onSendMessageFailure:(long)sessionId messageId:(long)messageId reason:(char *)reason code:(int)code
{
    return;
}

- (void)onSendOutOfDialogMessageSuccess:(long)messageId fromDisplayName:(char *)fromDisplayName from:(char *)from toDisplayName:(char *)toDisplayName to:(char *)to
{
    
}

- (void)onSendOutOfDialogMessageFailure:(long)messageId fromDisplayName:(char *)fromDisplayName from:(char *)from toDisplayName:(char *)toDisplayName to:(char *)to reason:(char *)reason code:(int)code
{
    
}

- (void)onSubscriptionFailure:(long)subscribeId
                   statusCode:(int)statusCode
{
    
}

- (void)onSubscriptionTerminated:(long)subscribeId
{
    
}

- (void)onPlayAudioFileFinished:(long)sessionId fileName:(char *)fileName
{
    int index = [self findLine:sessionId];
    if (index == -1) {
        return;
    }
    
    [self addLineStringToTableView:[NSString stringWithFormat:@"Play audio file - %s end on line : %d", fileName, index]];
    return;
}


- (void)onPlayVideoFileFinished:(long)sessionId
{
    int index = [self findLine:sessionId];
    if (index == -1) {
        return;
    }
    
    [self addLineStringToTableView:[NSString stringWithFormat:@"Play video file end of line : %d", index]];
    return;
}

- (void)onRTPPacketCallback:(long)sessionId mediaType:(int)mediaType direction:(DIRECTION_MODE)direction RTPPacket:(unsigned char *)RTPPacket packetSize:(int)packetSize
{
    /*
     !!! IMPORTANT !!!
     
     Don't call any PortSIP SDK API functions in here directly. If you want to call the PortSIP API functions or
     other code which will spend long time, you should post a message to main thread(main window) or other thread,
     let the thread to call SDK API functions or other code.
     
     */
}

- (void)onAudioRawCallback:(long)sessionId audioCallbackMode:(int)audioCallbackMode data:(unsigned char *)data dataLength:(int)dataLength samplingFreqHz:(int)samplingFreqHz
{
    /*
     !!! IMPORTANT !!!
     
     Don't call any PortSIP SDK API functions in here directly. If you want to call the PortSIP API functions or
     other code which will spend long time, you should post a message to main thread(main window) or other thread,
     let the thread to call SDK API functions or other code.
     
     */
    
    // The data parameter is audio stream as PCM format, 16bit, Mono.
    // the dataLength parameter is audio steam data length.
    
    
    
    //
    // IMPORTANT: the data length is stored in dataLength parameter!!!
    //
    
    DIRECTION_MODE type = (DIRECTION_MODE)audioCallbackMode;
    
    if (type == DIRECTION_SEND)
    {
        // The callback data is from local record device of each session, use the sessionId to identifying the session.
    }
    else if (type == DIRECTION_RECV)
    {
        // The callback data is received from remote side of each session, use the sessionId to identifying the session.
    }
    
    
    return;
}

- (int)onVideoRawCallback:(long)sessionId videoCallbackMode:(int)videoCallbackMode width:(int)width height:(int)height data:(unsigned char *)data dataLength:(int)dataLength
{
    /*
     !!! IMPORTANT !!!
     
     Don't call any PortSIP SDK API functions in here directly. If you want to call the PortSIP API functions or
     other code which will spend long time, you should post a message to main thread(main window) or other thread,
     let the thread to call SDK API functions or other code.
     
     The video data format is YUV420, YV12.
     */
    
    //
    // IMPORTANT: the data length is stored in dataLength parameter!!!
    //
    
    DIRECTION_MODE type = (DIRECTION_MODE)videoCallbackMode;
    
    if (type ==DIRECTION_SEND)
    {
        
    }
    else if (type == DIRECTION_RECV)
    {
        
    }

    return 0;
}


- (void)updateRemoteVideoWindowsSize:(int)width height:(int)height
{
    if(height <= 0 || width <= 0)
        return;
    
    if(mRemoteVideoHeight != height || mRemoteVideoWidth != width){
        //MUST run in dispatch_get_main_queue,
        dispatch_async(dispatch_get_main_queue(), ^{
            //here view do layout new frame
            CGRect rect = self->_uiviewRemote.frame;
            self->mRemoteVideoWidth  = width;
            self->mRemoteVideoHeight = height;
            
            rect.size.height = rect.size.width * height/width;
            
            self->_uiviewRemote.frame = rect;
            
            rect = [self->_uiviewRemote bounds];
            [self->_uiviewRemote updateVideoRenderFrame:rect];
            
        });
        NSLog(@"updateRemoteVideoWindowsSize width=%d height=%d", width, height);
    }
}


- (BOOL)isAutoAnswer
{
    for (int i = LINE_BASE; i < MAX_LINES; ++i) {
        if (mSessionArray[i].sessionState) {
            return YES;
        }
    }
    return NO;
}

- (int)getIdelLine
{
    int index = -1;
    for (int i = LINE_BASE; i < MAX_LINES; ++i) {
        if (mSessionArray[i].sessionState == NO && mSessionArray[i].recvCallState == NO) {
            mSessionArray[i].recvCallState = YES;
            index = i;
            break;
        }
    }
    return index;
}

- (int)findLine:(long)sessionId
{
    int index = -1;
    for (int i = LINE_BASE; i < MAX_LINES; ++i) {
        if (mSessionArray[i].sessionId == sessionId) {
            index = i;
            break;
        }
    }
    return index;
}

- (void)addLineStringToTableView:(NSString *)string
{
    
    NSDateFormatter *outputFormatter = [[NSDateFormatter alloc] init];
    [outputFormatter setLocale:[NSLocale currentLocale]];
    [outputFormatter setDateFormat:@"HH:mm:ss"];
    
    [_logData addObject:[@"" stringByAppendingFormat:@"%@ :%@",[outputFormatter stringFromDate:[NSDate date]],string]];
    [self.tableViewLog reloadData];
    
    [self.tableViewLog scrollRowToVisible:_logData.count - 1];
}


@end
